%SYS.INIT ;VCL/JPW-FREEM STARTUP ROUTINE; 10/23/2020 6:55 PM
    ;0.0;FreeM;****FREEM**;John P Willis @2020
    ;
    ;                            *
    ;                           * *
    ;                          *   *
    ;                     ***************
    ;                      * *       * *
    ;                       *  MUMPS  *
    ;                      * *       * *
    ;                     ***************
    ;                          *   *
    ;                           * *
    ;                            *
    ;
    ;   %ZFREEM.m
    ;    FreeM Startup Routine
    ;
    ;  
    ;   Author: John P. Willis <jpw@coherent-logic.com>
    ;    Copyright (C) 1998 MUG Deutschland
    ;    Copyright (C) 2020 Coherent Logic Development LLC
    ;
    ;
    ;   This file is part of FreeM.
    ;
    ;   FreeM is free software: you can redistribute it and/or modify
    ;   it under the terms of the GNU Affero Public License as published by
    ;   the Free Software Foundation, either version 3 of the License, or
    ;   (at your option) any later version.
    ;
    ;   FreeM is distributed in the hope that it will be useful,
    ;   but WITHOUT ANY WARRANTY; without even the implied warranty of
    ;   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    ;   GNU Affero Public License for more details.
    ;
    ;   You should have received a copy of the GNU Affero Public License
    ;   along with FreeM.  If not, see <https://www.gnu.org/licenses/>.
    ;    
    ;J ^%ZMAINT
    ;W "   PID:              ",$J,!
    ;W "   Principal I/O:    ",$PRINCIPAL,!,!
    Q
copyright ;
COPYRIGHT ;
    W "Coherent Logic Development ",$ZVERSION,!
    W "Copyright (C) 2014, 2020, 2021 Coherent Logic Development LLC",!,!
    W "License AGPLv3+: GNU AGPL version 3 or later <https://gnu.org/license/agpl-3.0.html>",!
    W "This is free software: you are free to change and redistribute it.",!
    W "There is NO WARRANTY, to the extent permitted by law.",!,!
    Q
info ;
    G INFO
    Q
INFO ;
	W $ZVERSION," (Namespace ",^$JOB($JOB,"NAMESPACE"),")",!,!
    W " Intrinsic Z-Commands:                                 '",$V(17),"'",!
    W " Intrinsic Z-Functions:                                '",$V(18),"'",!
    W " Intrinsic Special Variables:                          '",$V(19),"'",!
    W " Break Service Code:                                   '",$V(20),"'",!
    W " Last Referenced Global:                               '",$REFERENCE,"'",!
    W " Size of Last Global:                                  '",$V(21),"'",!
    W " Number of V22 Aliases:                                '",$V(22),"'",!
    W " Maximum Terminal Size:                                '",$V(25),"x",$V(24),"'",!
    W " FreeM Arguments:                                      '",$V(30),"'",!
    W " Maximum Routine Size:                                 '",$V(32),"'",!
    W " Number of Routine Buffers:                            '",$V(33),"'",!
    W " Maximum Concurrently-Open Globals:                    '",$V(35),"'",!
    W " Maximum Concurrently-Open I/O Channels:               '",$V(36),"'",!
    W " Maximum Size of Local Symbol Table:                   '",$V(37),"'",!
    W " Maximum Size of User-Defined Special Variable Table:  '",$V(39),"'",!
    W " Maximum Size of DO/XECUTE/FOR/BREAK Stack:            '",$V(41),"'",!
    W " Maximum Expression Stack Depth:                       '",$V(42),"'",!
    W " Maximum Number of Patterns:                           '",$V(43),"'",!,!
    Q
jobs ;
    G JOBS
    Q
JOBS ;     
    W " -== ",$ZVERSION," Job Manager ==-",!,!
jmmnu ;   
    W "PID",?7,"NAMESPACE",?20,"ROUTINE",?41,"$PRINCIPAL",?63,"UID:GID",!
    W "---",?7,"---------",?20,"-------",?41,"----------",?63,"-------",!
    S PID=""
    F  S PID=$O(^$JOB(PID)) Q:PID=""  D
    . W PID,?7,^$JOB(PID,"NAMESPACE"),?20,^$JOB(PID,"ROUTINE"),?41,^$JOB(PID,"$PRINCIPAL")
    . W ?63,^$JOB(PID,"USER"),":",^$JOB(PID,"GROUP")
    . I PID=$JOB W "*",!
    . I PID'=$JOB W !
    W !
    W "'*' represents the current process.",!
    W "Type 'quit' at the prompt to quit the Job Manager.",!,!
gpid ;   
    W "PID> " R PID W !
    Q:PID="quit"
    I '$D(^$JOB(PID)) W "Invalid PID",! G gpid
    W "Job PID "_PID_":",!
    W "  Current Namespace:     ",^$JOB(PID,"NAMESPACE"),!
    W "  Current Routine:       ",^$JOB(PID,"ROUTINE"),!
    W "  Value of $PRINCIPAL:   ",^$JOB(PID,"$PRINCIPAL"),!
    W "  Value of $IO:          ",^$JOB(PID,"$IO"),!
    W "  Process Owner:         ",^$JOB(PID,"USER"),!
    W "  Process Group:         ",^$JOB(PID,"GROUP"),!
    W "  Process $TLEVEL:       ",^$JOB(PID,"$TLEVEL"),!,!
jsel ;
    W "h)alt PID "_PID_" or c)hoose another? " R ACT#1
    I (ACT="h")!(ACT="H") K ^$JOB(PID) W !,"Sent SIGTERM to process "_PID_".",! G jmmnu
    W !,! G jmmnu
    Q
TRMSTAT ;
    G trmstat
trmstat ;
    W !,"FreeM Terminal Status",!
    W "---------------------",!,!
    W "ECHOON = "_^$DEVICE($P,"ECHOON")_" DELMODE = "_^$DEVICE($P,"DELMODE")_" ESCSEQPROC = "_^$DEVICE($P,"ESCSEQPROC"),!
    W "CONVUPPER = "_^$DEVICE($P,"CONVUPPER")_" DELEMPTY = "_^$DEVICE($P,"DELEMPTY")_" NOCTRLS = "_^$DEVICE($P,"NOCTRLS"),!
    W "CTRLOPROC = "_^$DEVICE($P,"CTRLOPROC")_" NOTYPEAHEAD = "_^$DEVICE($P,"NOTYPEAHEAD")_" TERMID = "_^$DEVICE($P,"TERMID"),!,!
    W "Device Status Word is "_^$DEVICE($P,"DSW"),!,!
    Q
rw ;
   W !,"---=== PROFESSOR RICHARD WALTERS ===---",!!
   W "UC Davis professor Richard Walters, the former director of the",!
   W "FreeM project, died on January 18, 2021 at the age of 90.",!,!
   W "The FreeM project--and the M community--owes him a great debt",!
   W "of gratitude.",!,!
   W "Rest in power, Professor Walters.",!,!
   W "Sincerely,",!
   W " - The FreeM Project",!,!
